/*
The following code is

© Andreas Amann, 2006-2011
http://andreasamann.com/
 
You may incorporate this code into your program(s) without restriction.
This code has been provided "AS IS" and the responsibility for its operation is yours.
You are not permitted to redistribute this code under my name after having made changes.
If you're going to redistribute the code, please make it clear that the code was descended
from my code, but that you've made changes.
*/

var SA_ = ( function() {
	var _growboxInset;
	var _currentLocation = ""; // base name for current location
	var _lon;
	var _lat;
	var _zoom;
	var _xSize;	// the current width and height of the widget
	var _ySize;
	var _defaultWidth;	// default width and height as specified in the plist
	var _defaultHeight;	// (we always use this when displaying the back)

	// contains default location and zoom setting for each location
	var _locations = [
		{region:"Alabama",name:"Birmingham",lat:33.52,lon:-86.80,zoom:2},
		{region:"Arizona",name:"Phoenix",lat:33.45,lon:-112.00,zoom:2},
		{name:"Tucson",lat:32.22,lon:-110.97,zoom:1},
		{region:"California",name:"Fresno",lat:36.75,lon:-119.77 ,zoom:1},
		{name:"Los Angeles",lat:34.04,lon:-118.22,zoom:3},
		{name:"Inland Empire",lat:33.96,lon:-117.38,zoom:3},
		{name:"Orange County",lat:33.7,lon:-117.8,zoom:2},
		{name:"Sacramento",lat:38.6,lon:-121.5,zoom:2},
		{name:"San Francisco",lat:37.7,lon:-122.16,zoom:3},
		{name:"San Diego",lat:32.82,lon:-117.12,zoom:2},
		{region:"Colorado",name:"Boulder",lat:40.01,lon:-105.27,zoom:1},
		{name:"Colorado Springs",lat:38.83,lon:-104.79,zoom:1},
		{name:"Denver",lat:39.74,lon:-104.99,zoom:2},
		{region:"Connecticut",name:"Hartford",lat:41.76,lon:-72.68,zoom:2},
		{name:"New Haven",lat:41.30,lon:-72.92,zoom:1},
		{name:"Westchester/Fairfield",lat:41.00,lon:-73.66,zoom:2},
		{region:"District of Columbia",name:"Washington,DC",lat:38.90,lon:-77.04,zoom:2},
		{region:"Florida",name:"Jacksonville",lat:30.33,lon:-81.66,zoom:2},
		{name:"Miami",lat:25.80,lon:-80.18,zoom:2},
		{name:"Orlando",lat:28.54,lon:-81.38,zoom:2},
		{name:"Tampa",lat:27.95,lon:-82.48,zoom:2},
		{name:"West Palm Beach",lat:26.71,lon:-80.06,zoom:2},
		{region:"Georgia",name:"Atlanta",lat:33.76,lon:-84.39,zoom:2},
		{region:"Illinois",name:"Chicago",lat:41.87,lon:-87.76,zoom:3},
		{region:"Indiana",name:"Fort Wayne",lat:41.08,lon:-85.13,zoom:2},
		{name:"Gary",lat:41.56,lon:-87.36,zoom:1},
		{name:"Indianapolis",lat:39.81,lon:-86.17,zoom:2},
		{region:"Kentucky",name:"Louisville",lat:38.25,lon:-85.76,zoom:1},
		{region:"Maryland",name:"Baltimore",lat:39.29,lon:-76.61,zoom:2},
		{region:"Massachusetts",name:"Boston",lat:42.37,lon:-71.11,zoom:1},
		{name:"Cape Cod",lat:41.75,lon:-70.78,zoom:2},
		{name:"Springfield",lat:42.10,lon:-72.59,zoom:1},
		{name:"Worcester",lat:42.27,lon:-71.82,zoom:1},
		{region:"Michigan",name:"Detroit",lat:42.37,lon:-83.21,zoom:2},
		{name:"Flint",lat:43.01,lon:-83.69,zoom:1},
		{name:"Grand Rapids",lat:42.96,lon:-85.67,zoom:1},
		{region:"Minnesota",name:"Minneapolis-St. Paul",lat:44.97,lon:-93.20,zoom:2},
		{region:"Missouri",name:"Kansas City",lat:39.10,lon:-94.58,zoom:2},
		{name:"St. Louis",lat:38.62,lon:-90.22,zoom:2},
		{region:"Nebraska",name:"Omaha",lat:41.22,lon:-95.99,zoom:2},
		{region:"Nevada",name:"Las Vegas",lat:36.11,lon:-115.17,zoom:2},
		{region:"New Jersey",name:"Central Jersey",lat:40.66,lon:-74.21,zoom:2},
		{name:"North Jersey",lat:40.91,lon:-74.17,zoom:2},
		{region:"New Mexico",name:"Albuquerque",lat:35.10,lon:-106.64,zoom:1},
		{region:"New York",name:"Albany",lat:42.65,lon:-73.75,zoom:1},
		{name:"Buffalo",lat:42.91,lon:-78.81,zoom:1},
		{name:"Long Island",lat:40.78,lon:-73.37,zoom:2},
		{name:"New York",lat:40.77,lon:-73.97,zoom:2},
		{name:"Rochester",lat:43.16,lon:-77.61,zoom:1},
		{name:"Syracuse",lat:43.05,lon:-76.15,zoom:1},
		{region:"North Carolina",name:"Charlotte",lat:35.23,lon:-80.84,zoom:2},
		{name:"Durham",lat:35.99,lon:-78.90,zoom:1},
		{name:"Greensboro",lat:36.07,lon:-79.79,zoom:1},
		{name:"Raleigh",lat:35.79,lon:-78.65,zoom:1},
		{name:"Winston-Salem",lat:36.10,lon:-80.25,zoom:1},
		{region:"Ohio",name:"Cincinnati",lat:39.13,lon:-84.50,zoom:2},
		{name:"Cleveland",lat:41.46,lon:-81.69,zoom:2},
		{name:"Columbus",lat:40.00,lon:-83.01,zoom:1},
		{name:"Dayton",lat:39.75,lon:-84.19,zoom:1},
		{name:"Toledo",lat:41.66,lon:-83.55,zoom:1},
		{region:"Oklahoma",name:"Oklahoma City",lat:35.49,lon:-97.55,zoom:2},
		{region:"Oregon",name:"Portland",lat:45.52,lon:-122.68,zoom:1},
		{region:"Pennsylvania",name:"Allentown",lat:40.61,lon:-75.49,zoom:2},
		{name:"Harrisburg",lat:40.27,lon:-76.88,zoom:1},
		{name:"Lancaster",lat:40.05,lon:-76.31,zoom:1},
		{name:"Philadelphia",lat:39.95,lon:-75.17,zoom:2},
		{name:"Pittsburgh",lat:40.44,lon:-79.99,zoom:2},
		{name:"Wilkes-Barre",lat:41.25,lon:-75.88,zoom:2},
		{region:"Rhode Island",name:"Providence",lat:41.82,lon:-71.41,zoom:2},
		{region:"South Carolina",name:"Greenville",lat:34.80,lon:-82.37,zoom:1},
		{region:"Tennessee",name:"Memphis",lat:35.13,lon:-89.99,zoom:2},
		{name:"Nashville",lat:36.16,lon:-86.78,zoom:2},
		{region:"Texas",name:"Austin",lat:30.27,lon:-97.75,zoom:1},
		{name:"Dallas",lat:32.77,lon:-96.80,zoom:2},
		{name:"Houston",lat:29.75,lon:-95.36,zoom:2},
		{name:"San Antonio",lat:29.43,lon:-98.51,zoom:2},
		{region:"Utah",name:"Salt Lake City",lat:40.74,lon:-111.93,zoom:2},
		{region:"Virginia",name:"Norfolk",lat:36.88,lon:-76.28,zoom:1},
		{name:"Richmond",lat:37.53,lon:-77.46,zoom:2},
		{region:"Washington",name:"Seattle",lat:47.59,lon:-122.24,zoom:2},
		{name:"Spokane",lat:47.66,lon:-117.43,zoom:1},
		{name:"Tacoma",lat:47.22,lon:-122.40,zoom:1},
		{region:"Wisconsin",name:"Milwaukee",lat:43.03,lon:-87.96,zoom:1}
	];

	var _getLocationForName = function(locationName)
	{
		for (var i = 0; i < _locations.length; i++)
			if (_locations[i].name == locationName) return _locations[i];
	}
	
	var _changeLocation = function(newLocation)
	{
		var oldLocation = _currentLocation;
		newLocation = _getLocationForName(newLocation);
		_currentLocation = newLocation.name;
		if ((oldLocation != "pre-selected") && (_currentLocation != oldLocation))
		// we switched from another location - reset the window size and map position to their default values
		// so we don't pan out of the visible area or display a window bigger than the new map
		{
			_lat = newLocation.lat;
			WC_.setInstancePref("latitude",_lat);
			_lon = newLocation.lon;
			WC_.setInstancePref("longitude",_lon);
			_zoom = newLocation.zoom;
			WC_.setInstancePref("zoom",_zoom);
			_xSize = _defaultWidth;
			WC_.setInstancePref("xSize",_xSize);
			_ySize = _defaultHeight;
			WC_.setInstancePref("ySize",_ySize);
			window.resizeTo(_xSize,_ySize);
		}
		_reloadMap();
	}
	
	var _reloadMap = function()
	{
		// load the map with the current parameter set
		var myLocation = _getLocationForName(_currentLocation);
		$("Map_ASP").src = ("http://www.sigalert.com/Widget/Dashboard.asp?lat=" + (_lat || myLocation.lat) + "&lon=" + (_lon || myLocation.lon) + "&z=" + (_zoom || myLocation.zoom) + "&partner=amann&urqs=1&th=brown");
	}

	return {
		load: function() {
				setupParts();
				var currentOptGroup = null;
				for (var i = 0; i < _locations.length; i++)
				{
					if (_locations[i].region)
					{
						currentOptGroup = $("locationPopup").appendChild(document.createElement("optgroup"));
						currentOptGroup.label = _locations[i].region;
					}
					currentOptGroup.appendChild(new Option(_locations[i].name));
				}
				_defaultWidth = WC_.getKeyValue("Width");
				_defaultHeight = WC_.getKeyValue("Height");
				$("Version").innerText = WC_.getKeyValue("CFBundleGetInfoString").replace("\n"," ");
				// set up our custom scrollbar for the detail popup
				// load prefs (or use default values if missing)
				_xSize = WC_.getInstancePref("xSize", window.innerWidth);
				_ySize = WC_.getInstancePref("ySize", window.innerHeight);

				if ( WC_.getInstancePref("currentLocation") && _getLocationForName(WC_.getInstancePref("currentLocation")) )
				{
					_currentLocation = "pre-selected"; // we need to set this to something well-known to prevent re-sizing the window to its default size upon first display…
					_changeLocation(WC_.getInstancePref("currentLocation"));
					$("locationPopup").value = WC_.getInstancePref("currentLocation");
					_ySize = WC_.getInstancePref("ySize");
					_xSize = WC_.getInstancePref("xSize");
					_lat = WC_.getInstancePref("latitude");
					_lon = WC_.getInstancePref("longitude");
					_zoom = WC_.getInstancePref("zoom");
				}
				else if (WC_.getPref("lastLocation") && _getLocationForName(WC_.getPref("lastLocation")) )
					$("locationPopup").value = WC_.getPref("lastLocation");
				$("locationText").innerText = $("locationPopup").value;
				// we need to fix visibility of some items when hitting cmd-R in Dashboard
				if (_currentLocation != "")
					SA_.showFront();
			},
		remove: function() {
				WC_.setInstancePref("currentLocation",null);
				WC_.setInstancePref("currentRoute",null);
				WC_.setInstancePref("xOffset",null);
				WC_.setInstancePref("yOffset",null);
				WC_.setInstancePref("xSize",null);
				WC_.setInstancePref("ySize",null);
				WC_.setInstancePref("latitude",null);
				WC_.setInstancePref("longitude",null);
				WC_.setInstancePref("zoom",null);
				SA_.hide();
			},
		hide: function() {
				// since the widget only refreshes on mouse-over we don't need to do anything here
			},
		show: function() {
				// if we have already have a preferred location, we show the current map - otherwise show the back so we can select one. Don't flip to the back if we are already showing the back
				if (!_getLocationForName(_currentLocation))
					_currentLocation = ""
				if (!_currentLocation || (_currentLocation == "" && $s("back").display != "block"))
					SA_.showBack();
				else
					_reloadMap();

			},
		showBack: function(event) {
				$("locationText").innerText = $("locationPopup").value;
				// work around a bug which causes the back to miss its bottom until the widget is moved
				// this will cause the front to resize before the flip but makes sure that we can actually see and use the back
				if (window.innerHeight < _defaultHeight)
					window.resizeTo(_defaultWidth,_defaultHeight);
				
				if (window.widget)
					widget.prepareForTransition("ToBack");

				$s("front").display = "none";
				$s("back").display = "block";
				
				// hide the canvas in order not to get double shadows around the widget (the default image has a shadow as well)
				$s("Canvas").visibility = "";

				if (window.widget)
				{
					window.resizeTo(_defaultWidth,_defaultHeight);
					setTimeout('widget.performTransition();', 0);
				}
			},
		showFront: function(event) {
				WC_.setInstancePref("currentLocation",$("locationPopup").value);
				WC_.setPref("lastLocation",$("locationPopup").value);
				
				if (window.widget)
				{
					window.resizeTo(_xSize,_ySize);
					widget.prepareForTransition("ToFront");
				}

				_changeLocation($("locationPopup").value);
				
				$s("front").display = "block";
				$s("back").display = "none";
				
				// we have this set as hidden per default in order not to get double shadows around the widget upon initial load
				$s("Canvas").visibility = "visible";
				// hide the fixed default image in order to allow resizing
				$s("frontImg").visibility = "hidden";
				
				if (window.widget)
					setTimeout('widget.performTransition();', 0);
			},
		MapZoom: function(zoomFactor) {
			_zoom = _zoom || _getLocationForName(_currentLocation).zoom;
			if ((zoomFactor < 0 && _zoom > 0) || (zoomFactor > 0 && _zoom < 3))
			{
				_zoom += zoomFactor;
				WC_.setInstancePref("zoom",_zoom);
				_reloadMap();
			}
		},
		MapMove: function(xMove,yMove) {
			var myLocation = _getLocationForName(_currentLocation);
			_zoom = _zoom || myLocation.zoom;
			_lon = _lon || myLocation.lon;
			_lat = _lat || myLocation.lat;
			if (xMove != 0)
			{
				_lon += xMove * 0.02 * (_zoom + 1);
				WC_.setInstancePref("longitude",_lon);
			}
			if (yMove != 0)
			{
				_lat += yMove * 0.02 * (_zoom + 1);
				WC_.setInstancePref("latitude",_lat);
			}
			_reloadMap();
		},
		mouseDown: function(event) {
				var pad = 31; // we have to take into account the borders around the map

				// don't let the user resize the window bigger than the map it contains
				document.addEventListener("mousemove", SA_.mouseMove, true);
				document.addEventListener("mouseup", SA_.mouseUp, true);

				_growboxInset = {x:(window.innerWidth - event.clientX), y:(window.innerHeight - event.clientY)};

				event.stopPropagation();
				event.preventDefault();
			},
		mouseMove: function(event) {
				var x = event.clientX + _growboxInset.x;
				var y = event.clientY + _growboxInset.y;
				var minWidth = 240;
				var minHeight = 160;
				var xMove;
				var yMove;
				
				x = Math.max(x, minWidth); // minimum width
				y = Math.max(y, minHeight); // minimum height

				// don't do additional calculations if we aren't actually resizing the window
				if (!(x == window.innerWidth && y == window.innerHeight))
				{
					// try to work around an annoying repaint bug which causes the bottom of the widget to disappear
					if (x == window.innerWidth && y != window.innerHeight)
						window.resizeTo(x+1,y);
					window.resizeTo(x,y);

					$s("resize").top = (y-12);

					event.stopPropagation();
					event.preventDefault();
				}
			},
		mouseUp: function(event) {
				document.removeEventListener("mousemove", SA_.mouseMove, true);
				document.removeEventListener("mouseup", SA_.mouseUp, true); 

				event.stopPropagation();
				event.preventDefault();

				_xSize = window.innerWidth;
				_ySize = window.innerHeight;
				
				WC_.setInstancePref("xSize",_xSize);
				WC_.setInstancePref("ySize",_ySize);
			}
	}
})();

if (window.widget)
{
	widget.onremove = SA_.remove;
	widget.onhide = SA_.hide;
	widget.onshow = SA_.show;
}
